/*
yasep/gui-js/winman.js
created ven. sept.  9 22:00:18 CEST 2011 by whygee@f-cpu.org
version lun. sept. 12 07:57:43 CEST 2011
version mar. sept. 13 09:21:06 CEST 2011 aliases, removed createCallback

This file uses a list of window keys to keep keyed windows open in only one instance.
It adds other fancy stuff too, such as patchInnerLinks or hiddenText ...

Dependencies : ygwm.js
Use : register_window() is called by all the files that create application windows or documentation,
  so it is included after ygwm and before the menu and the apps.
Note : the window creation function (given to register_window) must return the id of the ygwm_div element created.
*/

winman={
  // debug
///  dump_keys:"",

  window_keys:[],   // stores either a string (when alias)
  // or a key object (key name, on/off, creator function, ygwm id)

  // Add the key and function to the window keys table
  // new version : the whole object is passed, not just the function,
  //  so the key is added to the object
  register_window: function(key,f) {
    if ((typeof key != "string") || (typeof f != "function"))
      return alert("register_window : wrong argument type");
    if (winman.window_keys[key]) {
      if (key.substr(0,4) == "ISM/")
        return;
      else
        alert("key "+key+" already registered");
    };
    winman.window_keys[key]={func:f, on:false};
///    winman.dump_keys += key + "<br>";
  },

  // register an Alias (useful for aliases on ISM
  register_alias: function(alias, realkey) {
    if ((typeof alias != "string") || (typeof realkey != "string"))
      return alert("register_alias : wrong argument type");
    if (winman.window_keys[alias])
      return alert("key "+alias+" already registered");
// Not adapted to the ISM case, where the alias is registered before the aliasee
//    if (!winman.window_keys[realkey])
//      return alert("key "+realkey+" not yet registered ?");
    winman.window_keys[alias]=realkey;
///    winman.dump_keys += alias + " -> " + realkey + "<br>";
  },

  activate_window: function(key) {
    var v=key,v2,w=winman.window_keys

    // scan the alias linked list
    do{
      if (!w[v]) {
        alert("feature "+key+" ("+v+") is not (yet) created :-/");
        return false;
      }
      v2=v;
      v=w[v];
    } while (typeof v=="string");

    if (v.on==false){
      v.win = v.func(v2,key); // This way, one object can handle several keys ! handy for the ISM class...
      v.win.eraseCallback=function() {
        v.on=false;
      };
      v.on=true;
    }
    else {
      ygwm.focus_window(null,v.win);
    }
    return true;
  },

  innerLink: function(key_arg){
    var s,t;
    // when called from a A tag, "key_arg" is not a string so we examine the href
    if (typeof key_arg != "string") {
      t=this.href;
      s=t.indexOf("#!");
      key_arg = t.slice(s+2); // strip the link of the absolute path
    }
    // arguments are not treated yet.
    s=key_arg.split("#");
    winman.activate_window(s[0]);

    return false;
  },

  patchInnerLinks: function(base){
    if (!base)
      return;

    // Scan all the <a> tags
    var s,t,
     u=base.getElementsByTagName('a'),
     v="";
    for (var i in u){
      if(u[i].className=="asm"){
        u[i].href="#!tool/asm#"+u[i].innerHTML;
        u[i].onclick=winman.innerLink;
        u[i].className="asm_active";
      }
      else {
        if(u[i].className=="disasm"){
          u[i].href="#!tool/asm#;#"+u[i].innerHTML;
          u[i].onclick=winman.innerLink;
          u[i].className="disasm_active";
        }
        else {
          if (u[i].className=="opcode"){
          u[i].href="#!ISM/"+u[i].innerHTML;
          u[i].onclick=winman.innerLink;
          u[i].className="opcode_active";
          }
          else {
            if(u[i].href) {
              t=u[i].href;
              s=t.indexOf("#!");
              if (s >= 0) {
                t=t.slice(s+2);
                s=t.split("#");
                if(winman.window_keys[s[0]]) {
                  u[i].onclick=winman.innerLink;
                  u[i].className="innerLink";
                  v+=s[0];
                }
              }
            }
          }
        }
      }
    }
  }

};

// used by the applications to fetch hidden data from the .htmi
function hiddenText(key,base){
  return getById("hidden"+key,"SPAN",base).innerHTML;
}

